SystemOrganization addCategory: #'Pier-Tests-Security'!

!PRKernelTest methodsFor: '*pier-tests-security' stamp: 'nfr 10/18/2007 11:51'!
testGroupNamed
	| adminGroup found |
	self
		assert: (self kernel groupNamed: 'admin' ifNone: [self fail]) isNil not
		description: 'Should find admin group by its name'.
	adminGroup := self kernel groupNamed: 'admin' ifNone: [].
	self assert: (adminGroup isKindOf: PUGroup).
	self assert: (adminGroup name = 'admin').
	found := true.
	self kernel groupNamed: 'a group that is not there'
		ifNone: [found := false].
	self deny: found description: 'Should not find a group that is not there'! !

!PRKernelTest methodsFor: '*pier-tests-security' stamp: 'nfr 10/18/2007 11:52'!
testUserNamed
	| adminUser found |
	self
		assert: (self kernel userNamed: 'admin' ifNone: [self fail]) isNil not
		description: 'Should find admin group by its name'.
	adminUser := self kernel userNamed: 'admin' ifNone: [].
	self assert: (adminUser isKindOf: PUUser).
	self assert: (adminUser name = 'admin').
	found := true.
	self kernel userNamed: 'a user that is not there' ifNone: [found := false].
	self deny: found description: 'Should not find a user that is not there'! !

!PRAddCommandTest methodsFor: '*pier-tests-security' stamp: 'lr 6/22/2008 18:29'!
testGroup
	| parentDecoration childDecoration |
	parentDecoration := self context structure
		securityDecoration.
	parentDecoration
		owner: self bloggerUser;
		ownerPermissions: PUChangeSecurity permissionInstances;
		group: self adminGroup;
		groupPermissions: PRAddCommand permissions;
		otherPermissions: #().
	self context
		setUser: self bloggerUser.
	PRCurrentContext
		use: self
		during: [ self command execute ].

	childDecoration := self command answer structure
		securityDecoration.
	self assert: childDecoration owner = self bloggerUser.
	self assert: childDecoration ownerPermissions equalElements: PUChangeSecurity permissionInstances.
	self assert: childDecoration group = self adminGroup.
	self assert: childDecoration groupPermissions equalElements: PRAddCommand permissions.
	self assert: childDecoration otherPermissions equalElements: #()! !

!PRAddCommandTest methodsFor: '*pier-tests-security' stamp: 'lr 6/22/2008 18:29'!
testOwner
	| parentDecoration childDecoration |
	parentDecoration := self context structure
		securityDecoration.
	parentDecoration
		owner: self adminUser;
		ownerPermissions: PRAddCommand permissions;
		group: self bloggerGroup;
		groupPermissions: PUChangeSecurity permissionInstances;
		otherPermissions: #().
	self context
		setUser: self bloggerUser.
	PRCurrentContext
		use: self
		during: [ self command execute ].

	childDecoration := self command answer structure
		securityDecoration.
	self assert: childDecoration owner = self bloggerUser.
	self assert: childDecoration ownerPermissions equalElements: PRAddCommand permissions.
	self assert: childDecoration group = self bloggerGroup.
	self assert: childDecoration groupPermissions equalElements: PUChangeSecurity permissionInstances.
	self assert: childDecoration otherPermissions equalElements: #()! !

!PRAddCommandTest methodsFor: '*pier-tests-security' stamp: 'lr 6/22/2008 18:30'!
testWorld
	| parentDecoration childDecoration |
	parentDecoration := self context structure
		securityDecoration.
	parentDecoration
		owner: self adminUser;
		ownerPermissions: PUChangeSecurity permissionInstances;
		group: self adminGroup;
		groupPermissions: PUChangeSecurity permissionInstances;
		otherPermissions: PRAddCommand permissions.
	self context
		setUser: nil.
	PRCurrentContext
		use: self
		during: [ self command execute ].

	childDecoration := self command answer structure
		securityDecoration.
	self assert: childDecoration owner = self adminUser.
	self assert: childDecoration ownerPermissions equalElements: PUChangeSecurity permissionInstances.
	self assert: childDecoration group = self adminGroup.
	self assert: childDecoration groupPermissions equalElements: PUChangeSecurity permissionInstances.
	self assert: childDecoration otherPermissions equalElements: PRAddCommand permissions! !

!PRCommandTest methodsFor: '*pier-tests-security-accessing' stamp: 'lr 3/9/2006 11:30'!
adminGroup
	^ self kernel adminGroup! !

!PRCommandTest methodsFor: '*pier-tests-security-accessing' stamp: 'lr 3/9/2006 11:30'!
adminUser
	^ self kernel adminUser! !

!PRCommandTest methodsFor: '*pier-tests-security-accessing' stamp: 'lr 2/28/2010 18:19'!
bloggerGroup
	^ self kernel 
		groupNamed: 'blogger'
		ifNone: [ self kernel groups add: self bloggerGroupInstance ]! !

!PRCommandTest methodsFor: '*pier-tests-security-private' stamp: 'lr 3/9/2006 11:30'!
bloggerGroupInstance
	^ PUGroup named: 'blogger'! !

!PRCommandTest methodsFor: '*pier-tests-security-accessing' stamp: 'lr 2/28/2010 18:19'!
bloggerUser
	^ self kernel 
		userNamed: 'james'
		ifNone: [ self kernel users add: self bloggerUserInstance ]! !

!PRCommandTest methodsFor: '*pier-tests-security-private' stamp: 'lr 3/9/2006 11:30'!
bloggerUserInstance
	^ (PUUser named: 'james')
		addGroup: self bloggerGroup;
		password: 'bottom';
		yourself! !

PRCommandTest subclass: #PUChangeSecurityTest
	instanceVariableNames: 'child'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Security'!

PUChangeSecurityTest subclass: #PUChangeGroupTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Security'!

!PUChangeGroupTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PUChangeGroupTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
actualClass
	^ PUChangeGroup! !

!PUChangeGroupTest methodsFor: 'tests' stamp: 'lr 9/27/2007 10:08'!
testGroup
	self command
		with: true; all: true;
		group: self bloggerGroup.
	self command execute.

	self assert: self structure group = self bloggerGroup.
	self assert: self child group = self bloggerGroup! !

PUChangeSecurityTest subclass: #PUChangeOtherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Security'!

!PUChangeOtherTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PUChangeOtherTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
actualClass
	^ PUChangeOther! !

PUChangeSecurityTest subclass: #PUChangeOwnerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Security'!

!PUChangeOwnerTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PUChangeOwnerTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
actualClass
	^ PUChangeOwner! !

!PUChangeOwnerTest methodsFor: 'tests' stamp: 'lr 9/27/2007 10:08'!
testOwner
	self command
		with: true; all: true;
		owner: self bloggerUser.
	self command execute.

	self assert: self structure owner = self bloggerUser.
	self assert: self child owner = self bloggerUser! !

!PUChangeSecurityTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
actualClass
	^ PUChangeSecurity! !

!PUChangeSecurityTest methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
child
	^ child ifNil: [ child := self childInstance ]! !

!PUChangeSecurityTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
childInstance
	^ PRPage named: 'child'! !

!PUChangeSecurityTest methodsFor: 'accessing' stamp: 'lr 9/11/2006 10:42'!
permissions
	^ Set new
		addAll: PRAddCommand permissions;
		addAll: PRRemoveCommand permissions;
		yourself! !

!PUChangeSecurityTest methodsFor: 'private' stamp: 'lr 9/27/2007 10:08'!
structureInstance
	^ super structureInstance
		addChild: self child;
		yourself! !

!PUChangeSecurityTest methodsFor: 'tests-operations' stamp: 'lr 9/27/2007 10:07'!
testOperationAdd
	self command
		with: true; all: true;
		operator: #add; permissions: self permissions.
	self command execute.

	self assert: ((self command accessor read: self structure)
		includesAllOf: self permissions).
	self assert: ((self command accessor read: self child)
		includesAllOf: self permissions)! !

!PUChangeSecurityTest methodsFor: 'tests-operations' stamp: 'jf 10/1/2009 13:21'!
testOperationRemove
	| permissions |
	self command
		with: true; all: true;
		operator: #remove; permissions: self permissions.
	self command execute.
	
	permissions := self permissions.
	(self command accessor read: self structure) do:
		[ :each | self deny: (permissions includes: each) ].
	(self command accessor read: self child)do:
		[ :each | self deny: (permissions includes: each) ]! !

!PUChangeSecurityTest methodsFor: 'tests-operations' stamp: 'lr 6/22/2008 18:30'!
testOperationSet
	self command
		with: true; all: true;
		operator: #set; permissions: self permissions.
	self command execute.

	self assert: (self command accessor read: self structure) equalElements: self permissions.
	self assert: (self command accessor read: self child) equalElements: self permissions! !

!PUChangeSecurityTest methodsFor: 'tests-operations' stamp: 'lr 6/22/2008 18:30'!
testOperationUnchanged
	| structurePermission childPermissions |
	structurePermission := (self command accessor read: self structure)
		copy.
	childPermissions := (self command accessor read: self child)
		copy.

	self command
		with: true; all: true;
		operator: nil; permissions: self permissions.
	self command execute.

	self assert: (self command accessor
		read: self structure) equalElements: structurePermission.
	self assert: (self command accessor
		read: self child) equalElements: childPermissions! !

PRCommandTest subclass: #PUEditUserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Security'!

!PUEditUserTest class methodsFor: 'testing' stamp: 'lr 2/28/2010 18:07'!
isAbstract
	^ false! !

!PUEditUserTest methodsFor: 'private' stamp: 'lr 2/28/2010 18:06'!
actualClass
	^ PUEditUser! !

!PUEditUserTest methodsFor: 'tests' stamp: 'lr 2/28/2010 18:34'!
testInformation
	self context setUser: self adminUser.
	self command write: 'Lukas' using: PUUser descriptionFirstName.
	self command write: 'Renggli' using: PUUser descriptionLastName.
	self command write: 'admin@piercms.com' using: PUUser descriptionEmail.
	self shouldnt: [ self command execute ] raise: Error.
	self assert: self adminUser firstName = 'Lukas'.
	self assert: self adminUser lastName = 'Renggli'.
	self assert: self adminUser email = 'admin@piercms.com'.! !

!PUEditUserTest methodsFor: 'tests' stamp: 'lr 2/28/2010 18:32'!
testPassword
	self context setUser: self adminUser.
	self command write: 'foo' using: PUUser descriptionPassword.
	self shouldnt: [ self command execute ] raise: Error.
	self assert: (self adminUser validatePassword: 'foo')! !

!PUEditUserTest methodsFor: 'tests' stamp: 'lr 2/28/2010 18:24'!
testValid
	self deny: self context isValid.
	context := self context user: self adminUser.
	self assert: self context isValid.
	context := self context user: self bloggerUser.
	self assert: self context isValid! !

PRCommandTest subclass: #PULoginTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Security'!

!PULoginTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PULoginTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
actualClass
	^ PULogin! !

!PULoginTest methodsFor: 'tests-testing' stamp: 'lr 3/9/2006 11:30'!
testIsLogged
	self deny: self command isLogged! !

!PULoginTest methodsFor: 'tests' stamp: 'lr 1/12/2007 15:37'!
testLoginAdmin
	self assert: self context user isNil.
	self command
		username: self adminUser name;
		password: 'pier'.
	self
		shouldnt: [ self command execute ]
		raise: PUInvalidLogin.
	self assert: self command user = self adminUser.
	self assert: self command answer user = self adminUser.
	self assert: self command answer command class = PRViewCommand.
	self assert: self context user isNil! !

!PULoginTest methodsFor: 'tests' stamp: 'lr 1/12/2007 15:37'!
testLoginBlogger
	self assert: self context user isNil.
	self command
		username: self bloggerUser name;
		password: 'bottom'.
	self
		shouldnt: [ self command execute ]
		raise: PUInvalidLogin.
	self assert: self command user = self bloggerUser.
	self assert: self command answer user = self bloggerUser.
	self assert: self command answer command class = PRViewCommand.
	self assert: self context user isNil! !

!PULoginTest methodsFor: 'tests' stamp: 'lr 1/12/2007 15:37'!
testLoginInvalidPassword
	self assert: self context user isNil.
	self command username: self bloggerUser name.
	self should: [ self command execute ] raise: PUInvalidLogin.
	self assert: self context user isNil! !

!PULoginTest methodsFor: 'tests' stamp: 'lr 1/12/2007 15:37'!
testLoginInvalidUsername
	self assert: self context user isNil.
	self should: [ self command execute ] raise: PUInvalidLogin.
	self assert: self context user isNil! !

PRCommandTest subclass: #PULogoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Security'!

!PULogoutTest class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:31'!
isAbstract
	^ false! !

!PULogoutTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
actualClass
	^ PULogout! !

!PULogoutTest methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
contextInstance
	^ super contextInstance user: self bloggerUser! !

!PULogoutTest methodsFor: 'tests-testing' stamp: 'lr 3/9/2006 11:31'!
testIsLogged
	self deny: self command isLogged! !

!PULogoutTest methodsFor: 'tests-testing' stamp: 'lr 3/9/2006 11:31'!
testIsQuick
	self assert: self command isQuick! !

!PULogoutTest methodsFor: 'tests' stamp: 'lr 1/12/2007 15:36'!
testingLogout
	self assert: self context user = self bloggerUser.
	self command execute.
	self assert: self command answer user isNil.
	self assert: self command answer command class = PRViewCommand.
	self assert: self context user = self bloggerUser! !

PRDecorationTest subclass: #PRSecurityTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Security'!

!PRSecurityTest class methodsFor: 'testing' stamp: 'lr 8/31/2010 18:07'!
isAbstract
	^ false! !

!PRSecurityTest methodsFor: 'private' stamp: 'lr 8/31/2010 18:08'!
actualClass
	^ PUSecurity! !

TestCase subclass: #PUMemberTest
	instanceVariableNames: 'group1 group2 user1 user2 user3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Tests-Security'!

!PUMemberTest methodsFor: 'running' stamp: 'lr 9/27/2006 11:47'!
setUp
	group1 := PUGroup named: 'group 1'.
	group2 := PUGroup named: 'group 2'.

	user1 := PUUser named: 'user 1'.
	user2 := PUUser named: 'user 2'.
	user3 := PUUser named: 'user 3'! !

!PUMemberTest methodsFor: 'tests' stamp: 'lr 2/12/2007 19:07'!
testEqualitiy
	self assert: group1 = group1.
	self assert: group2 = group2.

	self assert: user1 = user1.
	self assert: user2 = user2.
	self assert: user3 = user3.

	self deny: group1 = group2.
	self deny: group2 = group1.

	self deny: user1 = user2.
	self deny: user2 = user3.
	self deny: user3 = user1.

	self deny: group1 = user1.
	self deny: group2 = user1.
	self deny: user1 = group1.
	self deny: user2 = group1.
	self deny: user3 = group1! !

!PUMemberTest methodsFor: 'tests-groups' stamp: 'lr 6/22/2008 18:31'!
testGroupUsers
	group1 users: (Array with: user1 with: user2).
	self assert: group1 users equalElements: (Set with: user1 with: user2).
	self assert: user1 groups = (OrderedCollection with: group1).
	self assert: user2 groups = (OrderedCollection with: group1).
	self assert: user3 groups = (OrderedCollection new).

	group1 users: (Array with: user2 with: user3).
	self assert: group1 users equalElements: (Set with: user2 with: user3).
	self assert: user1 groups = (OrderedCollection new).
	self assert: user2 groups = (OrderedCollection with: group1).
	self assert: user3 groups = (OrderedCollection with: group1)! !

!PUMemberTest methodsFor: 'tests' stamp: 'lr 9/27/2006 11:49'!
testName
	self assert: group1 name = 'group 1'.
	self assert: group2 name = 'group 2'.

	self assert: user1 name = 'user 1'.
	self assert: user2 name = 'user 2'.
	self assert: user3 name = 'user 3'! !

!PUMemberTest methodsFor: 'tests-user' stamp: 'lr 6/22/2008 18:31'!
testUserAddGroups
	user1 addGroup: group1; addGroup: group2.
	self assert: user1 group = group1.
	self assert: user1 groups = (OrderedCollection with: group1 with: group2).
	self assert: group1 users equalElements: (Set with: user1).
	self assert: group2 users equalElements: (Set with: user1)! !

!PUMemberTest methodsFor: 'tests-user' stamp: 'lr 6/22/2008 18:31'!
testUserGroups
	user1 groups: (Array with: group1 with: group2).
	self assert: user1 groups = (OrderedCollection with: group1 with: group2).
	self assert: group1 users equalElements: (Set with: user1).
	self assert: group2 users equalElements: (Set with: user1).

	user1 groups: (Array with: group1).
	self assert: user1 groups = (OrderedCollection with: group1).
	self assert: group1 users equalElements: (Set with: user1).
	self assert: group2 users equalElements: (Set new)! !

!PUMemberTest methodsFor: 'tests-user' stamp: 'lr 9/11/2008 16:19'!
testUserPassword
	user1 password: 'foo'.
	self deny: user1 password = 'foo'.
	self assert: (user1 validatePassword: 'foo').
	
	user1 password: user1 password.
	self assert: (user1 validatePassword: 'foo')! !

!PUMemberTest methodsFor: 'tests-user' stamp: 'lr 6/22/2008 18:31'!
testUserRemoveGroups
	user1 addGroup: group1; addGroup: group2; removeGroup: group2.
	self assert: user1 groups = (OrderedCollection with: group1).
	self assert: group1 users equalElements: (Set with: user1).
	self assert: group2 users equalElements: (Set new)! !

!PUMemberTest methodsFor: 'tests-user' stamp: 'lr 9/27/2006 11:53'!
testUserSuperuser
	self deny: user1 superuser.
	self deny: user1 isSuperuser.

	user1 superuser: true.
	self assert: user1 superuser.
	self assert: user1 isSuperuser! !

!TestCase methodsFor: '*pier-tests-security' stamp: 'lr 6/22/2008 18:28'!
assert: aCollection1 equalElements: aCollection2
	self assert: aCollection1 size = aCollection2 size.
	aCollection1 do: [ :each | self assert: (aCollection2 includes: each) ]! !

!GRPackage class methodsFor: '*pier-tests-security' stamp: 'lr 2/18/2010 10:36'!
pierTestsSecurity
	^ self new
		name: 'Pier-Tests-Security';
		description: 'Tests for the Pier security plugin.';
		addDependency: 'Pier-Security';
		addDependency: 'Pier-Tests-Model';
		url: #pierUrl;
		yourself! !
